Index: trunk/FACT++/gui/MainWindow.cc
===================================================================
--- trunk/FACT++/gui/MainWindow.cc	(revision 11944)
+++ trunk/FACT++/gui/MainWindow.cc	(revision 11949)
@@ -570,4 +570,9 @@
 }
 
+void MainWindow::on_fBiasOffsetDac_valueChanged(int val)
+{
+    fBiasOffsetVolt->setValue(val*90./4096);
+}
+
 void MainWindow::on_fBiasRequestStatus_clicked()
 {
@@ -592,4 +597,22 @@
     if (!fInHandler)
         Dim::SendCommand("BIAS_CONTROL/RESET_OVER_CURRENT_STATUS");
+}
+
+void MainWindow::on_fBiasDecrease_clicked()
+{
+    if (!fInHandler)
+        Dim::SendCommand("BIAS_CONTROL/DECREASE_GLOBAL_DAC", uint16_t(fBiasOffsetDac->value()));
+}
+
+void MainWindow::on_fBiasIncrease_clicked()
+{
+    if (!fInHandler)
+        Dim::SendCommand("BIAS_CONTROL/INCREASE_GLOBAL_DAC", -int16_t(fBiasOffsetDac->value()));
+}
+
+void MainWindow::on_fBiasApplyOffset_clicked()
+{
+    if (!fInHandler)
+        Dim::SendCommand("BIAS_CONTROL/SET_GAPD_REFERENCE_OFFSET", fBiasOffsetDac->value()*90./4096);
 }
 
Index: trunk/FACT++/gui/MainWindow.h
===================================================================
--- trunk/FACT++/gui/MainWindow.h	(revision 11944)
+++ trunk/FACT++/gui/MainWindow.h	(revision 11949)
@@ -164,4 +164,5 @@
     void on_fBiasCamPixel_valueChanged(int)  { BiasCamChannelChanged(); }
     void on_fBiasVoltDac_valueChanged(int);
+    void on_fBiasOffsetDac_valueChanged(int);
 
     void on_fBiasVoltMin_valueChanged(int); // FIXME: Could be set as slot in the designer
@@ -177,4 +178,7 @@
     void on_fBiasSetToZero_clicked();
     void on_fBiasReset_clicked();
+    void on_fBiasDecrease_clicked();
+    void on_fBiasIncrease_clicked();
+    void on_fBiasApplyOffset_clicked();
 
     virtual void on_fBiasDispRefVolt_stateChanged(int) = 0;
Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11944)
+++ trunk/FACT++/gui/design.ui	(revision 11949)
@@ -3302,5 +3302,5 @@
                <string>Controls</string>
               </property>
-              <layout class="QHBoxLayout" name="horizontalLayout_46" stretch="0,0,0,0,0">
+              <layout class="QHBoxLayout" name="horizontalLayout_46" stretch="0,0,0,0,0,0">
                <item>
                 <layout class="QGridLayout" name="gridLayout_87">
@@ -3680,4 +3680,69 @@
                    <property name="text">
                     <string>Global Apply</string>
+                   </property>
+                  </widget>
+                 </item>
+                </layout>
+               </item>
+               <item>
+                <layout class="QVBoxLayout" name="verticalLayout_18">
+                 <item>
+                  <widget class="QLabel" name="label_237">
+                   <property name="text">
+                    <string>Global voltage offset</string>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <widget class="QSpinBox" name="fBiasOffsetDac">
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="maximum">
+                    <number>4095</number>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <widget class="QDoubleSpinBox" name="fBiasOffsetVolt">
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="readOnly">
+                    <bool>true</bool>
+                   </property>
+                   <property name="buttonSymbols">
+                    <enum>QAbstractSpinBox::NoButtons</enum>
+                   </property>
+                   <property name="suffix">
+                    <string> V</string>
+                   </property>
+                   <property name="maximum">
+                    <double>90.000000000000000</double>
+                   </property>
+                  </widget>
+                 </item>
+                 <item>
+                  <layout class="QHBoxLayout" name="horizontalLayout_45">
+                   <item>
+                    <widget class="QPushButton" name="fBiasDecrease">
+                     <property name="text">
+                      <string>Decrease</string>
+                     </property>
+                    </widget>
+                   </item>
+                   <item>
+                    <widget class="QPushButton" name="fBiasIncrease">
+                     <property name="text">
+                      <string>Increase</string>
+                     </property>
+                    </widget>
+                   </item>
+                  </layout>
+                 </item>
+                 <item>
+                  <widget class="QPushButton" name="fBiasApplyOffset">
+                   <property name="text">
+                    <string>Set to G-APD ref + offset</string>
                    </property>
                   </widget>