Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11949)
+++ trunk/FACT++/gui/design.ui	(revision 11951)
@@ -3302,5 +3302,5 @@
                <string>Controls</string>
               </property>
-              <layout class="QHBoxLayout" name="horizontalLayout_46" stretch="0,0,0,0,0,0">
+              <layout class="QHBoxLayout" name="horizontalLayout_46" stretch="0,0,0,0,0,0,0,0,0,0,0,0">
                <item>
                 <layout class="QGridLayout" name="gridLayout_87">
@@ -3308,14 +3308,4 @@
                   <number>0</number>
                  </property>
-                 <item row="2" column="0">
-                  <widget class="QSpinBox" name="fBiasHvBoard">
-                   <property name="alignment">
-                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-                   </property>
-                   <property name="maximum">
-                    <number>9</number>
-                   </property>
-                  </widget>
-                 </item>
                  <item row="1" column="0">
                   <widget class="QLabel" name="label_229">
@@ -3323,10 +3313,26 @@
                     <string>Board</string>
                    </property>
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
                   </widget>
                  </item>
+                 <item row="0" column="1">
+                  <widget class="QLabel" name="label_202">
+                   <property name="text">
+                    <string>Bias supply</string>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignCenter</set>
+                   </property>
+                  </widget>
+                 </item>
                  <item row="1" column="1">
-                  <widget class="QLabel" name="label_230">
-                   <property name="text">
-                    <string>Channel</string>
+                  <widget class="QSpinBox" name="fBiasHvBoard">
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                   <property name="maximum">
+                    <number>9</number>
                    </property>
                   </widget>
@@ -3348,15 +3354,35 @@
                   </widget>
                  </item>
-                 <item row="0" column="0" colspan="2">
-                  <widget class="QLabel" name="label_202">
+                 <item row="2" column="0">
+                  <widget class="QLabel" name="label_230">
                    <property name="text">
-                    <string>Bias supply</string>
+                    <string>Channel</string>
                    </property>
                    <property name="alignment">
-                    <set>Qt::AlignCenter</set>
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
                    </property>
                   </widget>
                  </item>
+                 <item row="3" column="1">
+                  <spacer name="verticalSpacer_61">
+                   <property name="orientation">
+                    <enum>Qt::Vertical</enum>
+                   </property>
+                   <property name="sizeHint" stdset="0">
+                    <size>
+                     <width>20</width>
+                     <height>40</height>
+                    </size>
+                   </property>
+                  </spacer>
+                 </item>
                 </layout>
+               </item>
+               <item>
+                <widget class="Line" name="line_39">
+                 <property name="orientation">
+                  <enum>Qt::Vertical</enum>
+                 </property>
+                </widget>
                </item>
                <item>
@@ -3365,5 +3391,48 @@
                   <number>0</number>
                  </property>
+                 <item row="1" column="0">
+                  <widget class="QLabel" name="label_223">
+                   <property name="text">
+                    <string>Crate</string>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="0" column="1">
+                  <widget class="QLabel" name="label_206">
+                   <property name="text">
+                    <string>Camera</string>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignCenter</set>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="6" column="0">
+                  <spacer name="verticalSpacer_63">
+                   <property name="orientation">
+                    <enum>Qt::Vertical</enum>
+                   </property>
+                   <property name="sizeHint" stdset="0">
+                    <size>
+                     <width>20</width>
+                     <height>40</height>
+                    </size>
+                   </property>
+                  </spacer>
+                 </item>
                  <item row="2" column="0">
+                  <widget class="QLabel" name="label_224">
+                   <property name="text">
+                    <string>Board</string>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="1" column="1">
                   <widget class="QSpinBox" name="fBiasCamCrate">
                    <property name="alignment">
@@ -3385,18 +3454,4 @@
                   </widget>
                  </item>
-                 <item row="1" column="0">
-                  <widget class="QLabel" name="label_223">
-                   <property name="text">
-                    <string>Crate</string>
-                   </property>
-                  </widget>
-                 </item>
-                 <item row="1" column="1">
-                  <widget class="QLabel" name="label_224">
-                   <property name="text">
-                    <string>Board</string>
-                   </property>
-                  </widget>
-                 </item>
                  <item row="3" column="0">
                   <widget class="QLabel" name="label_222">
@@ -3404,7 +3459,20 @@
                     <string>Patch</string>
                    </property>
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
                   </widget>
                  </item>
                  <item row="4" column="0">
+                  <widget class="QLabel" name="label_231">
+                   <property name="text">
+                    <string>Pixel</string>
+                   </property>
+                   <property name="alignment">
+                    <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+                   </property>
+                  </widget>
+                 </item>
+                 <item row="3" column="1">
                   <widget class="QSpinBox" name="fBiasCamPatch">
                    <property name="alignment">
@@ -3413,11 +3481,4 @@
                    <property name="maximum">
                     <number>3</number>
-                   </property>
-                  </widget>
-                 </item>
-                 <item row="3" column="1">
-                  <widget class="QLabel" name="label_231">
-                   <property name="text">
-                    <string>Pixel</string>
                    </property>
                   </widget>
@@ -3442,15 +3503,12 @@
                   </widget>
                  </item>
-                 <item row="0" column="0" colspan="2">
-                  <widget class="QLabel" name="label_206">
-                   <property name="text">
-                    <string>Camera</string>
-                   </property>
-                   <property name="alignment">
-                    <set>Qt::AlignCenter</set>
-                   </property>
-                  </widget>
-                 </item>
                 </layout>
+               </item>
+               <item>
+                <widget class="Line" name="line_40">
+                 <property name="orientation">
+                  <enum>Qt::Vertical</enum>
+                 </property>
+                </widget>
                </item>
                <item>
@@ -3630,4 +3688,11 @@
                  </item>
                 </layout>
+               </item>
+               <item>
+                <widget class="Line" name="line_41">
+                 <property name="orientation">
+                  <enum>Qt::Vertical</enum>
+                 </property>
+                </widget>
                </item>
                <item>
@@ -3686,4 +3751,18 @@
                </item>
                <item>
+                <widget class="Line" name="line_43">
+                 <property name="orientation">
+                  <enum>Qt::Vertical</enum>
+                 </property>
+                </widget>
+               </item>
+               <item>
+                <widget class="Line" name="line_42">
+                 <property name="orientation">
+                  <enum>Qt::Vertical</enum>
+                 </property>
+                </widget>
+               </item>
+               <item>
                 <layout class="QVBoxLayout" name="verticalLayout_18">
                  <item>
@@ -3749,4 +3828,11 @@
                  </item>
                 </layout>
+               </item>
+               <item>
+                <widget class="Line" name="line_44">
+                 <property name="orientation">
+                  <enum>Qt::Vertical</enum>
+                 </property>
+                </widget>
                </item>
                <item>