Index: trunk/FACT++/src/RemoteControl.h
===================================================================
--- trunk/FACT++/src/RemoteControl.h	(revision 11982)
+++ trunk/FACT++/src/RemoteControl.h	(revision 11983)
@@ -121,6 +121,4 @@
     {
     }
-
-    //void SetReceiver(void *) { }
 
     bool PrintGeneralHelp()
Index: trunk/FACT++/src/argv.cc
===================================================================
--- trunk/FACT++/src/argv.cc	(revision 11982)
+++ trunk/FACT++/src/argv.cc	(revision 11983)
@@ -4,36 +4,4 @@
 
 using namespace std;
-
-template<class T,class S>
-std::ostream &operator<<(std::ostream &out, const pair<T,S> &f)
-{
-    out << f.first << "|" << f.second;
-    return out;
-}
-template<class T, class S>
-std::istream &operator>>(std::istream &in,  pair<T,S> &f)
-{
-    char c;
-    in >> f.first;
-    in >> c;
-    if (c!=':')
-        return in;
-    in >> f.second;
-    return in;
-}
-
-typedef pair<int,int> mytype;
-
-
-//Source is OutputStreamable, meaning that an operator<< is defined
-// that takes a std::ostream or std::wostream object on the left hand side
-// and an instance of the argument type on the right.
-
-// Target is InputStreamable, meaning that an operator>> is defined that
-// takes a std::istream or std::wistream object on the left hand side and
-// an instance of the result type on the right.
-
-//Target is CopyConstructible [20.1.3].
-//Target is DefaultConstructible, meaning that it is possible to default-initialize an object of that type [8.5, 20.1.4].
 
 // --------------------------------------------------------------------------
@@ -99,7 +67,4 @@
     po::options_description config("Configuration");
     config.add_options()
-        ("xxx", vars<int>(),             "Print available commandline options.")
-        ("test.*", var<int>(),             "Print available commandline options.")
-        ("map.*",  var<int>(),             "Print available commandline options.")
         ("compression",    var<int>(),                      "set compression level")
         ("optimization",   var<int>(10, &opt),              "optimization level")
@@ -117,5 +82,4 @@
         ("switch",        po_switch(),                    "include path")
         ("bool",          var<bool>()->implicit_value(true),                    "include path")
-        ("mytype",        var<mytype>(),                  "include path")
         ;
 
@@ -206,31 +170,6 @@
     cout << "Program " << argv[0] << " started successfully." << endl;
 
-    cout << conf.Has("test.A") << " " << conf.Get<int>("test.A") << endl;
-    cout << conf.Has("test.%") << " " << conf.Get<int>("test.%") << endl;
-    cout << conf.Has("test.9") << " " << conf.Get<int>("test.9") << endl;
-    cout << conf.Has("test.data") << " " << conf.Get<int>("test.data") << endl;
-    cout << conf.Has("test.pedestal") << " " << conf.Get<int>("test.pedestal") << endl;
-    cout << conf.Has("map.1") << " " << conf.Get<int>("map.1") << endl;
-    cout << conf.Has("map.2") << " " << conf.Get<int>("map.2") << endl;
-
-    return 0;
-
     cout << conf.Has("switch") << " " << conf.Get<bool>("switch") << endl;
-    cout << conf.Has("bool")   << " " << conf.Get<bool>("bool") << endl;
-    cout << conf.Has("mytype") << " " << conf.Get<mytype>("mytype") << endl;
-
-    cout << "---" << endl;
-    cout << conf.Has("test:A") << " " << conf.Get<int>("test:A") << endl;
-    cout << conf.Has("test:%") << " " << conf.Get<int>("test:%") << endl;
-    cout << conf.Has("test:9") << " " << conf.Get<int>("test:9") << endl;
-
-/*
-    map<string, int> m = conf.GetMap<int>("test:");
-
-    cout << m["test:A"] << endl;
-    cout << m["test:%"] << endl;
-    cout << m["test:9"] << endl;
-*/
-
+    cout << conf.Has("bool") << " " << conf.Get<bool>("bool") << endl;
 
     return 0;
Index: trunk/FACT++/src/logtime.cc
===================================================================
--- trunk/FACT++/src/logtime.cc	(revision 11982)
+++ trunk/FACT++/src/logtime.cc	(revision 11983)
@@ -6,9 +6,7 @@
 #include <iostream>
 
-#include "DimDescriptionService.h"
-
 int main(int, const char **)
 {
-    // We could use putenv to make the Configure class change the value...
+   // We could use putenv to make the Configure class change the value...
     setenv("DIM_DNS_NODE", "localhost", 0);
 
@@ -16,32 +14,6 @@
     DimServer::start("TIME");
 
-    usleep(2000000);
-
-    DimServer::stop();
-
-    return 0;
-
     // Some info on the console
     std::cout << "Offering TIME/MESSAGE...\n" << std::endl;
-
-    short s;
-    int i;
-    long long ll;
-    float f;
-    DimDescribedService servt("TIME/TEST", "O:1;I:1;C",
-                              "This is my test command|Char[c]:This is a char|   Int This is an int|String[s]:This is a string");
-
-    DimDescribedService servs("TIME/SHORT",     s,  "[a]");
-    DimDescribedService servx("TIME/LONGLONG",  ll, "|: This is my long long");
-    DimDescribedService servi("TIME/INT",       i,  "|MyInt  [  mi  ] ");
-    DimDescribedService servf("TIME/FLOAT",     f,  "|   MyFloat  :   This is my float");
-    DimDescribedService servc("TIME/TIME", const_cast<char*>(""), "|MyTime[T]:This is my time");
-
-    DimCommand cmd("TIME/CMD", "I:2;F:2");
-
-    DimDescriptionService des("TIME/CMD", "|range[addr]:From DAC to DAC|values[DAC]:DAC values to be set");
-
-    {
-    Time t0;
 
     // Setup a DimService called TIME/MESSAGE
@@ -51,21 +23,8 @@
         // Send current time
         msg.Message(Time().GetAsStr());
-//        servx.Update();
-        /*
-        servs.updateService();
-        servi.updateService();
-        servf.updateService();
-        servc.updateService();
-         */
+
         // wait approximately one second
-        usleep(100000);
-
-//        if (t0.UnixTime()-Time().UnixTime()<-5)
-//            break;
+        usleep(1000000);
     }
-    }
-
-    DimDescribedService servxx("TIME/XXX", const_cast<char*>(""), "|MyTime[T]:This is my time");
-    usleep(10000000);
 
     return 0;
Index: trunk/FACT++/src/mcp.cc
===================================================================
--- trunk/FACT++/src/mcp.cc	(revision 11982)
+++ trunk/FACT++/src/mcp.cc	(revision 11983)
@@ -55,5 +55,4 @@
         kStateConfiguring2,
         kStateConfiguring3,
-        kStateConfiguring4,
         kStateConfigured,
     };
@@ -272,6 +271,4 @@
     }
 
-    Time fConfigTimer;
-
     int Execute()
     {
@@ -320,17 +317,4 @@
                     return GetCurrentState();
 
-                fConfigTimer = Time();
-
-                return kStateConfiguring4;
-            }
-
-            if (GetCurrentState()==kStateConfiguring4)
-            {
-                // We need some delay to ensure that after sending the
-                // "Enable Trigger Line" command to all FADs the really
-                // have all already enabled the trigger line
-                if (Time()-fConfigTimer<boost::posix_time::milliseconds(100))
-                    return kStateConfiguring4;
-
                 Message("Starting Trigger (FTM)");
                 Dim::SendCommand("FTM_CONTROL/START_RUN");
@@ -407,7 +391,4 @@
 
         AddStateName(kStateConfiguring3, "Configuring3",
-                     ".");
-
-        AddStateName(kStateConfiguring4, "Configuring4",
                      ".");
 