Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 12049)
+++ trunk/FACT++/gui/FactGui.h	(revision 12050)
@@ -3630,53 +3630,10 @@
         // --------------------------------------------------------------------------
 
-        if (!fPixelMap.Read("FACTmapV5a.txt"))
-        {
-            cerr << "ERROR - Problems reading FACTmapV5a.txt" << endl;
+        if (!fPixelMap.Read(conf.Get<string>("pixel-map-file")))
+        {
+            cerr << "ERROR - Problems reading " << conf.Get<string>("pixel-map-file") << endl;
             exit(-1);
         }
 
-/*
-        ifstream fin0("FACTmapV5.txt");
-
-        int l = 0;
-
-        string buf;
-        while (getline(fin0, buf, '\n'))
-        {
-            if (l>1439)
-                break;
-
-            buf = Tools::Trim(buf);
-            if (buf[0]=='#')
-                continue;
-
-            stringstream str(buf);
-
-            int   idummy;
-            float fdummy;
-
-            PixelMapEntry entry;
-
-            str >> entry.index;
-            str >> entry.cbpx;
-            str >> idummy;
-            str >> idummy;
-            str >> entry.gapd;
-            str >> fdummy;
-            str >> entry.hv_board;
-            str >> entry.hv_channel;
-            str >> fdummy;
-            str >> fdummy;
-            str >> fdummy;
-
-            fPixelMap[l++] = entry;
-        }
-
-        if (l!=1440)
-        {
-            cerr << "ERROR - Problems reading FACTmapV5.txt" << endl;
-            exit(-1);
-        }
- */
         // --------------------------------------------------------------------------
 
Index: trunk/FACT++/src/biasctrl.cc
===================================================================
--- trunk/FACT++/src/biasctrl.cc	(revision 12049)
+++ trunk/FACT++/src/biasctrl.cc	(revision 12050)
@@ -1938,7 +1938,7 @@
 
         PixelMap map;
-        if (!map.Read("FACTmapV5.txt"))
-        {
-            T::Error("Reading reference voltages from FACTmapV5.txt failed.");
+        if (!map.Read(conf.Get<string>("pixel-map-file")))
+        {
+            T::Error("Reading reference voltages from "+conf.Get<string>("pixel-map-file")+" failed.");
             return 5;
         }
@@ -1981,6 +1981,6 @@
         ("volt-max-abs",    var<float>(75),      "Absolte upper limit for the voltage (in Volts)")
         ("volt-max-rel",    var<float>(2.5),     "Relative upper limit for the voltage w.r.t. the G-APD reference voltage (in Volts)")
+        ("pixel-map-file",  var<string>("FACTmapV5a.txt"), "Pixel mapping file. Used here to get the default reference voltage.")
         ;
-    // FIXME: Add a bit for OC... there is no -0
 
     conf.AddOptions(control);
Index: trunk/FACT++/src/feedback.cc
===================================================================
--- trunk/FACT++/src/feedback.cc	(revision 12049)
+++ trunk/FACT++/src/feedback.cc	(revision 12050)
@@ -592,22 +592,11 @@
     }
 
-    int EvalOptions(Configuration &)
-    {
-        //SetEndpoint(conf.Get<string>("addr"));
-
-        //fFSC.SetVerbose(!conf.Get<bool>("quiet"));
-
-        if (!fMap.Read("FACTmapV5a.txt"))
-        {
-            Error("Reading mapping table from FACTmapV5a.txt failed.");
+    int EvalOptions(Configuration &conf)
+    {
+        if (!fMap.Read(conf.Get<string>("pixel-map-file")))
+        {
+            Error("Reading mapping table from "+conf.Get<string>("pixel-map-file")+" failed.");
             return 1;
         }
-
-        /*
-        if (!fBias.SetNewGapdVoltage(map.Vgapd()))
-        {
-            T::Error("Setting reference voltages failed.");
-            return 6;
-        }*/
 
         return -1;
@@ -623,4 +612,14 @@
 {
     return Main::execute<T, StateMachineFeedback>(conf);
+}
+
+void SetupConfiguration(Configuration &conf)
+{
+    po::options_description control("BIAS control options");
+    control.add_options()
+        ("pixel-map-file",  var<string>("FACTmapV5a.txt"), "Pixel mapping file. Used here to get the default reference voltage.")
+        ;
+
+    conf.AddOptions(control);
 }
 
@@ -674,4 +673,5 @@
     conf.SetPrintUsage(PrintUsage);
     Main::SetupConfiguration(conf);
+    SetupConfiguration(conf);
 
     if (!conf.DoParse(argc, argv, PrintHelp))