Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 12077)
+++ trunk/FACT++/gui/FactGui.h	(revision 12078)
@@ -2750,6 +2750,4 @@
             fStatusFeedbackLabel->setText(s.name.c_str());
             fStatusFeedbackLabel->setToolTip(s.comment.c_str());
-
-            cout << s.index << endl;
 
             if (s.index==5) // Running
@@ -3868,10 +3866,16 @@
         // --------------------------------------------------------------------------
 
-        fGraphFtmRate.SetMarkerStyle(kFullDotSmall);
-        fGraphFtmRate.Draw("LP");
-
-        fGraphFtmRate.SetLineColor(kBlue);
-        fGraphFtmRate.SetMarkerColor(kBlue);
-        fGraphFtmRate.SetMarkerStyle(kFullDotMedium);
+        c = fFtmRateCanv->GetCanvas();
+        //c->SetBit(TCanvas::kNoContextMenu);
+        c->SetBorderMode(0);
+        c->SetFrameBorderMode(0);
+        c->SetFillColor(kWhite);
+        c->SetRightMargin(0.03);
+        c->SetTopMargin(0.03);
+        c->SetGrid();
+        c->cd();
+
+	hf = DrawTimeFrame("Trigger rate [Hz]");
+        hf->GetYaxis()->SetRangeUser(0, 1010);
 
         for (int i=0; i<160; i++)
@@ -3889,4 +3893,10 @@
             fGraphBoardRate[i].SetMarkerStyle(kFullDotMedium);
         }
+
+        fGraphFtmRate.SetLineColor(kBlue);
+        fGraphFtmRate.SetMarkerColor(kBlue);
+        fGraphFtmRate.SetMarkerStyle(kFullDotSmall);
+        fGraphFtmRate.Draw("LP");
+
         /*
         TCanvas *c = fFtmTempCanv->GetCanvas();
@@ -3921,53 +3931,4 @@
         // --------------------------------------------------------------------------
 
-        c = fFtmRateCanv->GetCanvas();
-        //c->SetBit(TCanvas::kNoContextMenu);
-        c->SetBorderMode(0);
-        c->SetFrameBorderMode(0);
-        c->SetFillColor(kWhite);
-        c->SetRightMargin(0.03);
-        c->SetTopMargin(0.03);
-        c->SetGrid();
-        c->cd();
-
-	hf = DrawTimeFrame("Trigger rate [Hz]");
-        hf->GetYaxis()->SetRangeUser(0, 1010);
-
-        fGraphFtmRate.SetMarkerStyle(kFullDotSmall);
-        fGraphFtmRate.Draw("LP");
-
-        // --------------------------------------------------------------------------
-        fFeedbackDevCam->setAutoscaleLowerLimit((fFeedbackDevMin->minimum()+0.5*fFeedbackDevMin->singleStep())*0.001);
-        fFeedbackDevCam->SetMin(fFeedbackDevMin->value()*0.001);
-        fFeedbackDevCam->SetMax(fFeedbackDevMax->value()*0.001);
-        fFeedbackDevCam->updateCamera();
-
-        fFeedbackDevCam->setAutoscaleLowerLimit((fFeedbackCmdMin->minimum()+0.5*fFeedbackCmdMin->singleStep())*0.001);
-        fFeedbackCmdCam->SetMin(fFeedbackCmdMin->value()*0.001);
-        fFeedbackCmdCam->SetMax(fFeedbackCmdMax->value()*0.001);
-        fFeedbackCmdCam->updateCamera();
-
-        // --------------------------------------------------------------------------
-
-        fBiasCamV->setAutoscaleLowerLimit((fBiasVoltMin->minimum()+0.5*fBiasVoltMin->singleStep())*0.001);
-        fBiasCamV->SetMin(fBiasVoltMin->value());
-        fBiasCamV->SetMax(fBiasVoltMax->value());
-        fBiasCamV->updateCamera();
-
-        fBiasCamA->setAutoscaleLowerLimit((fBiasCurrentMin->minimum()+0.5*fBiasCurrentMin->singleStep())*0.001);
-        fBiasCamA->SetMin(fBiasCurrentMin->value());
-        fBiasCamA->SetMax(fBiasCurrentMax->value());
-        fBiasCamA->updateCamera();
-
-        // --------------------------------------------------------------------------
-
-        fRatesCanv->setAutoscaleLowerLimit((fRatesMin->minimum()+0.5*fRatesMin->singleStep())*0.001);
-        fRatesCanv->SetMin(fRatesMin->value());
-        fRatesCanv->SetMax(fRatesMax->value());
-        fRatesCanv->updateCamera();
-        on_fPixelIdx_valueChanged(0);
-
-        // --------------------------------------------------------------------------
-
         c = fAdcDataCanv->GetCanvas();
         //c->SetBit(TCanvas::kNoContextMenu);
@@ -3977,7 +3938,37 @@
         c->SetRightMargin(0.10);
         c->SetGrid();
-        c->cd();
-
-        // Create histogram?
+        //c->cd();
+#endif
+
+        // --------------------------------------------------------------------------
+        fFeedbackDevCam->setAutoscaleLowerLimit((fFeedbackDevMin->minimum()+0.5*fFeedbackDevMin->singleStep())*0.001);
+        fFeedbackDevCam->SetMin(fFeedbackDevMin->value()*0.001);
+        fFeedbackDevCam->SetMax(fFeedbackDevMax->value()*0.001);
+        fFeedbackDevCam->updateCamera();
+
+        fFeedbackDevCam->setAutoscaleLowerLimit((fFeedbackCmdMin->minimum()+0.5*fFeedbackCmdMin->singleStep())*0.001);
+        fFeedbackCmdCam->SetMin(fFeedbackCmdMin->value()*0.001);
+        fFeedbackCmdCam->SetMax(fFeedbackCmdMax->value()*0.001);
+        fFeedbackCmdCam->updateCamera();
+
+        // --------------------------------------------------------------------------
+
+        fBiasCamV->setAutoscaleLowerLimit((fBiasVoltMin->minimum()+0.5*fBiasVoltMin->singleStep())*0.001);
+        fBiasCamV->SetMin(fBiasVoltMin->value());
+        fBiasCamV->SetMax(fBiasVoltMax->value());
+        fBiasCamV->updateCamera();
+
+        fBiasCamA->setAutoscaleLowerLimit((fBiasCurrentMin->minimum()+0.5*fBiasCurrentMin->singleStep())*0.001);
+        fBiasCamA->SetMin(fBiasCurrentMin->value());
+        fBiasCamA->SetMax(fBiasCurrentMax->value());
+        fBiasCamA->updateCamera();
+
+        // --------------------------------------------------------------------------
+
+        fRatesCanv->setAutoscaleLowerLimit((fRatesMin->minimum()+0.5*fRatesMin->singleStep())*0.001);
+        fRatesCanv->SetMin(fRatesMin->value());
+        fRatesCanv->SetMax(fRatesMax->value());
+        fRatesCanv->updateCamera();
+        on_fPixelIdx_valueChanged(0);
 
         // --------------------------------------------------------------------------
@@ -4048,5 +4039,4 @@
         connect(fAdcDataCanv, SIGNAL(     RootEventProcessed(TObject*, unsigned int, TCanvas*)),
                 this,         SLOT  (slot_RootEventProcessed(TObject*, unsigned int, TCanvas*)));
-#endif
     }
 