Index: /trunk/FACT++/gui/design.ui
===================================================================
--- /trunk/FACT++/gui/design.ui	(revision 12134)
+++ /trunk/FACT++/gui/design.ui	(revision 12135)
@@ -3574,4 +3574,10 @@
                  <item row="5" column="1">
                   <widget class="QDoubleSpinBox" name="fBiasCurrent">
+                   <property name="sizePolicy">
+                    <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                     <horstretch>0</horstretch>
+                     <verstretch>0</verstretch>
+                    </sizepolicy>
+                   </property>
                    <property name="alignment">
                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -3587,5 +3593,5 @@
                    </property>
                    <property name="maximum">
-                    <double>5000.000000000000000</double>
+                    <double>9999999.000000000000000</double>
                    </property>
                   </widget>
@@ -3690,4 +3696,10 @@
                  <item row="2" column="1">
                   <widget class="QDoubleSpinBox" name="fBiasVoltRef">
+                   <property name="sizePolicy">
+                    <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                     <horstretch>0</horstretch>
+                     <verstretch>0</verstretch>
+                    </sizepolicy>
+                   </property>
                    <property name="alignment">
                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -3762,4 +3774,10 @@
                  <item row="4" column="1">
                   <widget class="QDoubleSpinBox" name="fBiasVoltCur">
+                   <property name="sizePolicy">
+                    <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                     <horstretch>0</horstretch>
+                     <verstretch>0</verstretch>
+                    </sizepolicy>
+                   </property>
                    <property name="alignment">
                     <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -3808,4 +3826,10 @@
                    <item>
                     <widget class="QDoubleSpinBox" name="fBiasVolt">
+                     <property name="sizePolicy">
+                      <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                       <horstretch>0</horstretch>
+                       <verstretch>0</verstretch>
+                      </sizepolicy>
+                     </property>
                      <property name="alignment">
                       <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -3821,5 +3845,5 @@
                      </property>
                      <property name="maximum">
-                      <double>90.000000000000000</double>
+                      <double>9999.000000000000000</double>
                      </property>
                     </widget>
@@ -3827,4 +3851,10 @@
                    <item>
                     <widget class="QSpinBox" name="fBiasVoltDac">
+                     <property name="sizePolicy">
+                      <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                       <horstretch>0</horstretch>
+                       <verstretch>0</verstretch>
+                      </sizepolicy>
+                     </property>
                      <property name="alignment">
                       <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -3909,4 +3939,10 @@
                    <item>
                     <widget class="QDoubleSpinBox" name="fBiasOffsetVolt">
+                     <property name="sizePolicy">
+                      <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                       <horstretch>0</horstretch>
+                       <verstretch>0</verstretch>
+                      </sizepolicy>
+                     </property>
                      <property name="alignment">
                       <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -3925,5 +3961,5 @@
                      </property>
                      <property name="maximum">
-                      <double>90.000000000000000</double>
+                      <double>9999.000000000000000</double>
                      </property>
                     </widget>
@@ -3931,4 +3967,10 @@
                    <item>
                     <widget class="QSpinBox" name="fBiasOffsetDac">
+                     <property name="sizePolicy">
+                      <sizepolicy hsizetype="Preferred" vsizetype="Fixed">
+                       <horstretch>0</horstretch>
+                       <verstretch>0</verstretch>
+                      </sizepolicy>
+                     </property>
                      <property name="alignment">
                       <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>